Added support for p4config.
[puppet_vcsrepo.git] / lib / puppet / type / vcsrepo.rb
1 require 'pathname'
2
3 Puppet::Type.newtype(:vcsrepo) do
4   desc "A local version control repository"
5
6   feature :gzip_compression,
7           "The provider supports explicit GZip compression levels"
8   feature :basic_auth,
9           "The provider supports HTTP Basic Authentication"
10   feature :bare_repositories,
11           "The provider differentiates between bare repositories
12           and those with working copies",
13           :methods => [:bare_exists?, :working_copy_exists?]
14
15   feature :filesystem_types,
16           "The provider supports different filesystem types"
17
18   feature :reference_tracking,
19           "The provider supports tracking revision references that can change
20            over time (eg, some VCS tags and branch names)"
21
22   feature :ssh_identity,
23           "The provider supports a configurable SSH identity file"
24
25   feature :user,
26           "The provider can run as a different user"
27
28   feature :modules,
29           "The repository contains modules that can be chosen of"
30
31   feature :multiple_remotes,
32           "The repository tracks multiple remote repositories"
33
34   feature :configuration,
35           "The configuration directory to use"
36
37   feature :cvs_rsh,
38           "The provider understands the CVS_RSH environment variable"
39
40   feature :depth,
41           "The provider can do shallow clones"
42
43   feature :p4config,
44           "The provider understands Perforce Configuration"
45
46   ensurable do
47     attr_accessor :latest
48
49     def insync?(is)
50       @should ||= []
51
52       case should
53       when :present
54         return true unless [:absent, :purged, :held].include?(is)
55       when :latest
56         if is == :latest
57           return true
58         else
59           return false
60         end
61       when :bare
62         return is == :bare
63       end
64     end
65
66     newvalue :present do
67       notice "Creating repository from present"
68       provider.create
69     end
70
71     newvalue :bare, :required_features => [:bare_repositories] do
72       if !provider.exists?
73         provider.create
74       end
75     end
76
77     newvalue :absent do
78       provider.destroy
79     end
80
81     newvalue :latest, :required_features => [:reference_tracking] do
82       if provider.exists? && !@resource.value(:force)
83         if provider.respond_to?(:update_references)
84           provider.update_references
85         end
86         if provider.respond_to?(:latest?)
87             reference = provider.latest || provider.revision
88         else
89           reference = resource.value(:revision) || provider.revision
90         end
91         notice "Updating to latest '#{reference}' revision"
92         provider.revision = reference
93       else
94         notice "Creating repository from latest"
95         provider.create
96       end
97     end
98
99     def retrieve
100       prov = @resource.provider
101       if prov
102         if prov.working_copy_exists?
103           if @resource.value(:force)
104             if noop?
105               notice "Noop Mode - Would have deleted repository"
106               notice "Noop Mode - Would have created repository from latest"
107             else
108               notice "Deleting current repository before recloning"
109               prov.destroy
110               notice "Create repository from latest"
111               prov.create
112             end
113           end
114           (@should.include?(:latest) && prov.latest?) ? :latest : :present
115         elsif prov.class.feature?(:bare_repositories) and prov.bare_exists?
116           :bare
117         else
118           :absent
119         end
120       else
121         raise Puppet::Error, "Could not find provider"
122       end
123     end
124
125   end
126
127   newparam :path do
128     desc "Absolute path to repository"
129     isnamevar
130     validate do |value|
131       path = Pathname.new(value)
132       unless path.absolute?
133         raise ArgumentError, "Path must be absolute: #{path}"
134       end
135     end
136   end
137
138   newparam :source do
139     desc "The source URI for the repository"
140   end
141
142   newparam :fstype, :required_features => [:filesystem_types] do
143     desc "Filesystem type"
144   end
145
146   newproperty :revision do
147     desc "The revision of the repository"
148     newvalue(/^\S+$/)
149   end
150
151   newparam :owner do
152     desc "The user/uid that owns the repository files"
153   end
154
155   newparam :group do
156     desc "The group/gid that owns the repository files"
157   end
158
159   newparam :user do
160     desc "The user to run for repository operations"
161   end
162
163   newparam :excludes do
164     desc "Files to be excluded from the repository"
165   end
166
167   newparam :force do
168     desc "Force repository creation, destroying any files on the path in the process."
169     newvalues(:true, :false)
170     defaultto false
171   end
172
173   newparam :compression, :required_features => [:gzip_compression] do
174     desc "Compression level"
175     validate do |amount|
176       unless Integer(amount).between?(0, 6)
177         raise ArgumentError, "Unsupported compression level: #{amount} (expected 0-6)"
178       end
179     end
180   end
181
182   newparam :basic_auth_username, :required_features => [:basic_auth] do
183     desc "HTTP Basic Auth username"
184   end
185
186   newparam :basic_auth_password, :required_features => [:basic_auth] do
187     desc "HTTP Basic Auth password"
188   end
189
190   newparam :identity, :required_features => [:ssh_identity] do
191     desc "SSH identity file"
192   end
193
194   newparam :module, :required_features => [:modules] do
195     desc "The repository module to manage"
196   end
197
198   newparam :remote, :required_features => [:multiple_remotes] do
199     desc "The remote repository to track"
200     defaultto "origin"
201   end
202
203   newparam :configuration, :required_features => [:configuration]  do
204     desc "The configuration directory to use"
205   end
206
207   newparam :cvs_rsh, :required_features => [:cvs_rsh] do
208     desc "The value to be used for the CVS_RSH environment variable."
209   end
210
211   newparam :depth, :required_features => [:depth] do
212     desc "The value to be used to do a shallow clone."
213   end
214
215   newparam :p4config, :required_features => [:p4config] do
216     desc "The Perforce P4CONFIG environment."
217   end
218
219   autorequire(:package) do
220     ['git', 'git-core']
221   end
222
223   def noop?
224     if defined?(@noop)
225       @noop
226     else
227       Puppet[:noop]
228     end
229   end
230
231 end